                    INCLUDE  Map.s

	AREA    InitializePROC,CODE,READONLY
		
__main              PROC
                    EXPORT   __main
					IMPORT   MAIN
					;BL       RCCInitialize
					BL       MAIN
					B    .
					ENDP
RCCInitialize       PROC
					LDR      R0,=RCC
					LDRB     R1,[R0,#RCCCFGR+0x02]
					ORR      R1,#0x1D ;HCLK: 72MHz
					STRB     R1,[R0,#0x02]
;PLL input clock x 9, HSE oscillator clock selected as PLL input clock. 
;PLLMUL: 0111, PLLSRC: 1.
                    LDRB     R1,[R0,#RCCCFGR+0x01]
					;ORR      R1,#0x84  ;HCLK: 72MHz
					ORR      R1,#0xC4  ;HCLK: 120MHz or 112.896MHz
					STRB     R1,[R0,#RCCCFGR+0x01]
;HCLK divided by 2, PCLK2 divided by 6. PPRE1: 100, ADCPRE: 10.
                    LDR      R0,=FLASH   
					LDR      R1,[R0,#FLASHACR]
					ORR      R1,#0x02
					STR      R1,[R0,#FLASHACR]
;Two wait states. LATENCY: 010
                    LDR      R0,=RCC
					LDRB     R1,[R0,#RCCCR+0x02]
					ORR      R1,#0x01
					STRB     R1,[R0,#RCCCR+0x02]
WaitHSEReady        LDRB     R1,[R0,#RCCCR+0x02]
					AND      R1,#0x02
					CMP      R1,#0x02
					BNE      WaitHSEReady
					LDRB     R1,[R0,#RCCCR+0x03]
					ORR      R1,#0x01
					STRB     R1,[R0,#RCCCR+0x03]
WaitPLLReady        LDRB     R1,[R0,#RCCCR+0x03]
                    AND      R1,#0x02
					CMP      R1,#0x02
                    BNE      WaitPLLReady
;HSE Oscillator ON,PLL ON. HSEON: 1, PLLON: 1.
					LDRB     R1,[R0,#RCCCFGR]
					ORR      R1,#0x02
					STRB     R1,[R0,#RCCCFGR]
WaitClockSwitch		LDRB     R1,[R0,#RCCCFGR]
					NOP
					AND      R1,#0x0C
					CMP      R1,#0x08
					BNE      WaitClockSwitch
;PLL selected as system clock. SW: 10.
                    LDRB     R1,[R0,#RCCCFGR]
					AND      R1,#0xFE
					STRB     R1,[R0,#RCCCFGR]
;Internal 8 MHz RC oscillator OFF. HSEON: 0.
                    BX       R14
					ENDP
					ALIGN
					END