	 AREA    OddsPROC,CODE,READONLY

;UDIV64              PROC
	                ;EXPORT      UDIV64
					;PUSH        {R4-R6,R14}
					;CMP         R1,#0x00
					;ITTE        EQ
					;CLZEQ       R5,R0
					;ADDEQ       R5,#0x20
					;CLZNE       R5,R1
					;CMP         R3,#0x00
					;ITTE        EQ
					;CLZEQ       R6,R2
					;ADDEQ       R6,#0x20
					;CLZNE       R6,R3
					;SUBS        R6,R5
					;BLO         UDIV64ZeroResult
					;SUBS        R4,R6,#0x20
					;BLO         UDIV64RSLT32
					;LSR         R4,R1,R4
					;MOV         R5,#0x00
					;B           UDIV64RSEnd
;UDIV64RSLT32		LSR         R4,R0,R6
					;RSB         R5,R6,#0x20
					;LSL         R5,R1,R5
					;ORR         R4,R5
					;LSR         R5,R1,R6
;UDIV64RSEnd		    RSBS        R14,R6,#0x20
                    ;BLO         UDIV64LSLT32
					;LSL         R1,R0,R14
					;MOV         R0,#0x00
					;B           UDIV64SubChk
;UDIV64LSLT32		RSB         R6,#0x40
                    ;LSL         R1,R6
					;RSB         R14,R6,#0x20
					;LSR         R14,R0,R14
					;ORR         R1,R14
					;LSL         R0,R6
					;B           UDIV64SubChk
;UDIV64Loop			LSLS        R4,#0x01
                    ;LSL         R5,#0x01
					;ADC         R5,#0x00
					;LSLS        R1,#0x01
					;ADC         R4,#0x00
                    ;LSLS        R0,#0x01
					;ADC         R1,#0x00
;UDIV64SubChk        CMP         R4,R2
					;SBCS        R14,R5,R3
                    ;BLO         UDIV64SubSkip
                    ;ADD         R0,#0x01
                    ;SUBS        R4,R2
					;SBC         R5,R3
;UDIV64SubSkip       SUBS        R6,#0x01
					;BHS         UDIV64Loop
					;POP         {R4-R6,R15}
;UDIV64ZeroResult    MOV         R1,#0x00
                    ;MOV         R0,#0x00
                    ;POP         {R4-R6,R15}
	                ;ENDP
;DoubleDivToDouble   PROC
	                ;EXPORT      DoubleDivToDouble
	                ;PUSH        {R4-R7,R14}
					;EOR         R14,R1,R3
					;UBFX        R4,R1,#0x14,#0x0B
					;UBFX        R5,R3,#0x14,#0x0B
					;SUB         R4,R5
					;ADD         R4,#0x03FF
					;BFI         R14,R4,#0x14,#0x0B
					;UBFX        R5,R1,#0x00,#0x14
					;BFC         R3,#0x14,#0x0C
					;ORR         R5,#0x100000
					;ORR         R3,#0x100000
					;MOV         R4,R0
					;CMP         R0,R2
					;SBCS        R6,R5,R3
					;ITTE        LO
					;MOVLO       R6,#0x37
					;SUBLO       R14,#0x100000
					;MOVHS       R6,#0x36
;DDTDDivLoop         LSLS        R0,#0x01
					;LSL         R1,#0x01
					;ADC         R1,#0x00
                    ;CMP         R4,R2
					;SBCS        R7,R5,R3
                    ;BLO         DDTDSubSkip
                    ;ADD         R0,#0x01
                    ;SUBS        R4,R2
					;SBC         R5,R3
;DDTDSubSkip         LSLS        R4,#0x01
					;LSL         R5,#0x01
					;ADC         R5,#0x00
					;SUBS        R6,#0x01
                    ;BNE         DDTDDivLoop
					;LSL         R4,R1,#0x1F
					;LSR         R1,#0x01
					;LSRS        R0,#0x01
					;ORR         R0,R4
                    ;LSR         R14,#0x14
					;BFI         R1,R14,#0x14,#0x0C
					;ADCS        R0,#0x00
					;ADC         R1,#0x00
					;POP         {R4-R7,R15}
	                ;ENDP
;FloatAdd2           PROC
	                ;EXPORT      FloatAdd2
					;PUSH        {R14}
					;EOR         R14,R1,R0
					;TST         R14,#0x80000000
					;BEQ         FAPPOrNN
;FAPAndN             UBFX        R2,R0,#0x17,#0x08
					;UBFX        R3,R1,#0x17,#0x08
					;CBZ         R2,FAR0IsZero
                    ;CBZ         R3,FAR1IsZero
				    ;SUBS        R14,R2,R3
					;ITT         LO
				    ;SUBLO       R14,R3,R2
					;MOVLO       R2,R3
					;MOV         R3,#0x80000000
			 	    ;ORR         R0,R3,R0,LSL#0x08
			        ;ORR         R3,R1,LSL#0x08
					;ITE         LO
				    ;LSRLO       R0,R14
				    ;LSRHS       R3,R14
					;LSR         R1,#0x1F
					;CBZ         R1,FAR0N
				    ;SUBS        R14,R0,R3
				    ;BEQ         FAZeroResult
;FAR1N   		    ITT         LO
				    ;SUBLO       R14,R3,R0
				    ;ORRLO       R2,#0x0100
				    ;CLZ         R3,R14
				    ;LSL         R14,R3
				    ;LSRS        R14,#0x08
				    ;SUB         R2,R3
				    ;LSL         R0,R2,#0x17
				    ;BFI         R0,R14,#0x00,#0x17
				    ;ADC         R0,#0x00
;FAR1IsZero          POP         {R15}
;FAR0IsZero          MOV         R0,R1
					;POP         {R15}         
;FAR0N               SUBS        R14,R3,R0
				    ;BEQ         FAZeroResult
                    ;ITT         LO
				    ;SUBLO       R14,R0,R3
				    ;ORRLO       R0,#0x0100
				    ;CLZ         R3,R14
				    ;LSL         R14,R3
				    ;LSRS        R14,#0x08
				    ;SUB         R2,R3
				    ;LSL         R0,R2,#0x17
				    ;BFI         R0,R14,#0x00,#0x17
				    ;ADC         R0,#0x00
                    ;POP         {R15}
;FAZeroResult		MOV         R0,#0x00
            		;POP         {R15}
;FAPPOrNN            MOV         R3,#0x80000000
			 	    ;ORR         R2,R3,R0,LSL#0x08
			        ;ORR         R3,R1,LSL#0x08
                    ;UBFX        R0,R0,#0x17,#0x09
					;UBFX        R1,R1,#0x17,#0x09
                    ;SUBS        R14,R0,R1
                    ;ITTTE       LS
                    ;SUBLS       R14,R1,R0
					;MOVLS       R0,R1
                    ;LSRLS       R2,R14
                    ;LSRHI       R3,R14
                    ;ADDS        R2,R3
					;ADC         R0,#0x00
					;MOV         R3,#0x08
					;ADC         R3,#0x00
					;LSRS        R2,R3
					;LSL         R0,#0x17
					;BFI         R0,R2,#0x00,#0x17
					;ADC         R0,#0x00
                    ;POP         {R15}
					;ENDP
;FloatDivide2        PROC
	                ;EXPORT      FloatDivide2
					;PUSH        {R14}
					;UBFX        R2,R0,#0x17,#0x08
					;UBFX        R3,R1,#0x17,#0x08
					;;CBZ         R2,FDZeroOperand
					;SUB         R2,R3
					;ADD         R2,#0x7E
					;MOV         R14,#0x80000000
					;ORR         R3,R14,R0,LSL#0x08
					;EOR         R0,R1
					;BFI         R0,R2,#0x17,#0x08
                    ;ORR         R1,R14,R1,LSL#0x08
					;LSR         R3,#0x02
					;LSR         R2,R1,#0x10
					;UDIV        R14,R3,R2
					;MLS         R3,R2,R14,R3
					;LSL         R3,#0x10
					;UDIV        R3,R2
					;ORR         R3,R14,LSL#0x10
					;BFC         R1,#0x10,#0x10
					;RSB         R1,R2,LSL#0x02
					;UDIV        R1,R2
					;UMULL       R1,R2,R1,R3
					;LSRS        R1,R2,#0x10
					;ADD         R0,R1,LSL#0x17
					;ADD         R1,#0x10
					;LSRS        R2,R1
					;BFI         R0,R1,#0x00,#0x17
					;ADC         R0,#0x00
					;POP         {R15}
					;ENDP
					END